# opkbuild
# lib/common
# Functions for stack memory management.
#
# Copyright (C) 2012 Patrick "P. J." McDermott
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

[ -n "${_OB_COMMON_SM}" ] && return 0
_OB_COMMON_SM='true'

_OB_STACK_VARS=
_OB_SAVED_IFS=

_ob_local()
{
	# Push the variable list onto the stack.
	_OB_STACK_VARS="${_OB_STACK_VARS}|${*}"

	# Save the old IFS value, if any, and set it to its default.
	_OB_SAVED_IFS="${IFS}"
	IFS=' 	
'
}

_ob_return()
{
	# Unset the variables at the top of the stack.
	IFS=' '
	unset -v ${_OB_STACK_VARS##*|}

	# Pop the variable list from the top of the stack.
	_OB_STACK_VARS="${_OB_STACK_VARS%|*}"

	# Restore the saved IFS.
	IFS="${_OB_SAVED_IFS}"

	return ${1}
}

_ob_validate_var_name()
{
	case "${1}" in
		[!a-zA-Z_]*|*[!a-zA-Z0-9_]*)
			return 1
			;;
	esac
	return 0
}
